"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const utils_1 = require("./utils");
const bpeFile = fs_1.default.readFileSync(path_1.default.join(__dirname, '../data/vocab.bpe'), 'utf8');
const lines = bpeFile.split('\n');
const bpeMerges = lines.slice(1, -1).map((x) => x
    .split(/(\s+)/)
    .filter((e) => e.trim().length > 0)
    .join(','));
const bpeRanks = (0, utils_1.dictZip)(bpeMerges, (0, utils_1.range)(0, bpeMerges.length));
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
const encoder = require('../data/encoder.json');
fs_1.default.mkdirSync(path_1.default.join(__dirname, 'data'), { recursive: true });
fs_1.default.writeFileSync(path_1.default.join(__dirname, 'data/bpeRanks.js'), `/* eslint-disable */\n// @ts-nocheck\n// prettier-ignore\nexport default ${JSON.stringify(bpeRanks)}`);
fs_1.default.writeFileSync(path_1.default.join(__dirname, 'data/encoder.js'), `/* eslint-disable */\n// @ts-nocheck\n// prettier-ignore\nexport default ${JSON.stringify(encoder)}`);
//# sourceMappingURL=getData.js.map