export declare function bpe(token: string, cache?: Map<string, string>): string;
export declare function encodeGenerator(text: string, cache?: Map<string, string>): Generator<number[], void, undefined>;
/**
 * @returns {false | number} false if token limit is exceeded, otherwise the number of tokens
 */
export declare function isWithinTokenLimit(text: string, tokenLimit: number, cache?: Map<string, string>): false | number;
export declare function encode(text: string, cache?: Map<string, string>): number[];
export declare function decodeToken(token: number): string;
export declare function endsWithIncompleteUtfPairSurrogate(string: string): boolean;
export declare function decodeGenerator(tokens: Iterable<number>): Generator<string, void, undefined>;
/**
 * Decode tokens asynchronously and yield the decoded strings, one by one.
 * Will not yield for tokens that include a high surrogate, but wait for the next token.
 * @param {AsyncIterable<number>} tokens
 * @returns {AsyncGenerator<string, void, undefined>}
 */
export declare function decodeAsyncGenerator(tokens: AsyncIterable<number>): AsyncGenerator<string, void, undefined>;
export declare function decode(tokens: number[]): string;
declare const gptEncoder: {
    encode: typeof encode;
    decode: typeof decode;
    encodeGenerator: typeof encodeGenerator;
    decodeGenerator: typeof decodeGenerator;
    decodeAsyncGenerator: typeof decodeAsyncGenerator;
    isWithinTokenLimit: typeof isWithinTokenLimit;
    bpe: typeof bpe;
};
export default gptEncoder;
