"use strict";
/* eslint-disable unicorn/prefer-spread */
/* eslint-disable unicorn/prefer-code-point */
Object.defineProperty(exports, "__esModule", { value: true });
exports.splitToken = exports.getPairs = exports.getCharFromCode = exports.getCharCode = exports.range = exports.dictZip = void 0;
/**
 * @template T
 * @template U
 * @param {T[]} x
 * @param {U[]} y
 * @returns {Record<T, U>}
 */
function dictZip(x, y) {
    /** @type {Record<T, U>} */
    const result = {};
    x.forEach((k, i) => {
        result[k] = y[i];
    });
    return result;
}
exports.dictZip = dictZip;
/**
 * @param {number} x
 * @param {number} y
 * @returns {number[]}
 */
function range(x, y) {
    return Array.from({ length: y - x }, (_, i) => x + i);
}
exports.range = range;
/**
 * @param {string} x
 * @returns {number}
 */
const getCharCode = (x) => x.charCodeAt(0);
exports.getCharCode = getCharCode;
/**
 * @param {number} x
 * @returns {string}
 */
const getCharFromCode = (x) => String.fromCharCode(x);
exports.getCharFromCode = getCharFromCode;
/**
 * @param {string[]} word
 * @returns {[string, string][]}
 */
function getPairs(word) {
    /** @type {[string, string][]} */
    const pairs = [];
    let prevChar = word[0];
    for (let i = 1; i < word.length; i++) {
        const char = word[i];
        pairs.push([prevChar, char]);
        prevChar = char;
    }
    return pairs;
}
exports.getPairs = getPairs;
/**
 * @param {string} token
 * @returns {string[]}
 */
const splitToken = (token) => token.split('');
exports.splitToken = splitToken;
//# sourceMappingURL=utils.js.map